/* next-i386.h:  definitions for NeXT.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "i386mach.h"
#include "next.h"


/* By default, target has a 80387, with IEEE FP.  */

#undef TARGET_DEFAULT
#define TARGET_DEFAULT  (1|0100)


#undef STACK_BOUNDARY
/* Boundary (in *bits*) on which stack pointer should be aligned.  */
#define STACK_BOUNDARY 32


/* Names to predefine in the preprocessor for this target machine.  */

#undef	CPP_PREDEFINES
#define CPP_PREDEFINES "-Di386 -DNeXT -Dunix -D__MACH__ \
-D__LITTLE_ENDIAN__ -D__ARCHITECTURE__=\"i386\""


/* We do not define JUMP_TABLES_IN_TEXT_SECTION, since we wish to keep
   the text section pure.  There is no point in addressing the jump
   tables using pc relative addressing, since they are not in the text
   section, so we undefine CASE_VECTOR_PC_RELATIVE.  This also
   causes the compiler to use absolute addresses in the jump table,
   so we redefine CASE_VECTOR_MODE to be SImode. */

#undef CASE_VECTOR_MODE
#define CASE_VECTOR_MODE SImode

#undef CASE_VECTOR_PC_RELATIVE

#define SELECT_RTX_SECTION(mode, rtx) const_section ()

/* Don't treat addresses involving labels differently from symbol names.
   Previously, references to labels generated pc-relative addressing modes
   while references to symbol names generated absolute addressing modes.  */

#undef GO_IF_INDEXABLE_BASE(X, ADDR)
#define GO_IF_INDEXABLE_BASE(X, ADDR)				\
{ if (GET_CODE (X) == REG && REG_OK_FOR_BASE_P (X)) goto ADDR; }


/* This accounts for the return pc and saved fp on the i386. */
#define OBJC_FORWARDING_STACK_OFFSET 8
#define OBJC_FORWARDING_MIN_OFFSET 8


/* This is how to output an internal numbered label which
   labels a jump table.  */

#define ASM_OUTPUT_CASE_LABEL(FILE,PREFIX,NUM,JUMPTABLE)	\
  do { const_section ();					\
       ASM_OUTPUT_INTERNAL_LABEL(FILE,PREFIX,NUM); } while (0)

/* Output at the end of a jump table.  */

#define ASM_OUTPUT_CASE_END(FILE,NUM,INSN)			\
  text_section ();


/* Output to assembler file text saying following lines
   may contain character constants, extra white space, comments, etc.  */

#undef ASM_APP_ON
#define ASM_APP_ON "#APP\n"

/* Output to assembler file text saying following lines
   no longer contain unusual constructs.  */

#undef ASM_APP_OFF
#define ASM_APP_OFF "#NO_APP\n"





/* BEGIN Calling Convention CHANGES */

/*
 * These changes violate the Intel/Unix ABI.  Specifically, they change the
 * way that space for a block return value is passed to a function.  The ABI
 * says that the pointer is passed on the stack.  We change to pass the pointer
 * in %ebx.  This makes the NeXT Objective-C forwarding mechanism possible
 * to implement on an i386.
 */

/*
 * Do NOT pass address of structure values on the stack
 */
#undef STRUCT_VALUE_INCOMING
#undef STRUCT_VALUE

/*
 * Pass them in %ebx
 */
#undef STRUCT_VALUE_REGNUM
#define STRUCT_VALUE_REGNUM 3


/*
 * Because we are passing the pointer in a register, we don't
 * need to rely on the callee to pop it
 */
#undef RETURN_POPS_ARGS
#define RETURN_POPS_ARGS(FUNTYPE,SIZE)   \
  (TREE_CODE (FUNTYPE) == IDENTIFIER_NODE ? 0                   \
   : (TARGET_RTD                                                \
      && (TYPE_ARG_TYPES (FUNTYPE) == 0                         \
          || (TREE_VALUE (tree_last (TYPE_ARG_TYPES (FUNTYPE))) \
              == void_type_node))) ? (SIZE)                     \
   :0)

/* END Calling Convention CHANGES */



/*
 * This is being overridden because the default i386 configuration
 * generates calls to "_mcount".  NeXT system libraries all use
 * "mcount".
 */
#undef FUNCTION_PROFILER
#define FUNCTION_PROFILER(FILE, LABELNO)  \
{                                                                       \
  if (flag_pic)                                                         \
    {                                                                   \
      fprintf (FILE, "\tleal %sP%d@GOTOFF(%%ebx),%%edx\n",              \
               LPREFIX, (LABELNO));                                     \
      fprintf (FILE, "\tcall *mcount@GOT(%%ebx)\n");                   \
    }                                                                   \
  else                                                                  \
    {                                                                   \
      fprintf (FILE, "\tmovl $%sP%d,%%edx\n", LPREFIX, (LABELNO));      \
      fprintf (FILE, "\tcall mcount\n");                               \
    }                                                                   \
}

