/* next-m88.h:  definitions for NeXT.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
 * This define tells the m88k.h config file to NOT include SVR3 SDB (etc) 
 * configuration information.
 */
#define DBX_DEBUGGING_INFO

#include "m88k.h"


/* Output an insn to serialize the processor before volatile memory refs. */

#define FINAL_PRESCAN_INSN(INSN,OPERANDS,NOPERANDS)     \
{                                                       \
  if (get_attr_volatile (INSN) == VOLATILE_YES)         \
    fprintf (asm_out_file, "\ttb1\t 0,r0,128\n");       \
}

#undef CONSTANT_ALIGNMENT
#undef DATA_ALIGNMENT

#include "next.h"

#undef SDB_DEBUGGING_INFO

/* Changes for our assembler. */

#undef TEXT_SECTION_ASM_OP
#define TEXT_SECTION_ASM_OP	"\t.text"
#undef DATA_SECTION_ASM_OP
#define DATA_SECTION_ASM_OP	"\t.data"
#undef CONST_SECTION_ASM_OP
#define CONST_SECTION_ASM_OP	"\t.const"

#undef ASM_OUTPUT_IDENT
#undef ASM_OUTPUT_SOURCE_FILENAME


#undef GLOBAL_ASM_OP
#define GLOBAL_ASM_OP		".globl"
#undef SKIP_ASM_OP
#define SKIP_ASM_OP		".space"
#undef COMMON_ASM_OP
#define COMMON_ASM_OP		".comm"
#undef LOCAL_ASM_OP
#define LOCAL_ASM_OP		".lcomm"
#undef FLOAT_ASM_OP
#define FLOAT_ASM_OP		".single"
#undef DOUBLE_ASM_OP
#define DOUBLE_ASM_OP		".double"
#undef INT_ASM_OP
#define INT_ASM_OP		".long"
#undef SHORT_ASM_OP
#define SHORT_ASM_OP		".short"
#undef CHAR_ASM_OP
#define CHAR_ASM_OP		".byte"
#undef ASCII_DATA_ASM_OP
#define ASCII_DATA_ASM_OP	".ascii"

#undef ASM_OUTPUT_INTERNAL_LABEL
#define ASM_OUTPUT_INTERNAL_LABEL(FILE,PREFIX,NUM)      \
  fprintf (FILE, "%s%d:\n", PREFIX, NUM)

#undef ASM_GENERATE_INTERNAL_LABEL
#define ASM_GENERATE_INTERNAL_LABEL(LABEL,PREFIX,NUM)                   \
  sprintf (LABEL, "*%s%d", PREFIX, NUM)

/* End of assembler changes */


#undef ASM_OUTPUT_SOURCE_LINE

/* Names to predefine in the preprocessor for this target machine.  */

#undef CPP_PREDEFINES
#define CPP_PREDEFINES "-Dnrw -Dm88k -DNATURAL_ALIGNMENT -DNeXT -Dunix -D__MACH__ \
-D__BIG_ENDIAN__ -D__ARCHITECTURE__=\"m88k\" -D__CLASSIFY_TYPE__=2 " NEXT_PREDEFINES

/* Don't warn about nans, infinities or denorms.  */
#undef CHECK_FLOAT_VALUE

/* Only align functions to 4-byte boundaries.  */
#undef FUNCTION_BOUNDARY
#define FUNCTION_BOUNDARY 32

/* This accounts for the saved arg registers on the m88k. */

#define OBJC_FORWARDING_STACK_OFFSET 32

#define OBJC_FORWARDING_REG_OFFSET 0

#define OBJC_FORWARDING_MIN_OFFSET 0

#define OBJC_FORWARDING_FIRST_REG 2

#undef ASM_FILE_START
#define ASM_FILE_START(FILE) \
  fprintf (FILE, ".include \"architecture/m88k/workaround.s\"\n"); \
  fprintf (FILE, "\t.file\t\"%s\"\n", dump_base_name);

#undef SIZE_TYPE

#undef FRAME_POINTER_REQUIRED
#define FRAME_POINTER_REQUIRED \
  (frame_pointer_needed || write_symbols != NO_DEBUG)

