/* next-m98.h:  definitions for NeXT.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */


#include "rs6000.h"

#define DBX_DEBUGGING_INFO
#undef XCOFF_DEBUGGING_INFO
#undef OBJECT_FORMAT_COFF

/* Output an insn to serialize the processor before volatile memory refs. */

#define FINAL_PRESCAN_INSN(INSN,OPERANDS,NOPERANDS)     \
{                                                       \
  if (get_attr_volatile (INSN) == VOLATILE_YES)         \
    fprintf (asm_out_file, "\teieio\n");                \
}

#undef CONSTANT_ALIGNMENT
#undef DATA_ALIGNMENT

#include "next.h"

#undef SELECT_RTX_SECTION
void select_rtx_section();
#define SELECT_RTX_SECTION(mode, rtx) select_rtx_section(mode,rtx);

#undef SDB_DEBUGGING_INFO

/* BEGIN Calling Convention CHANGES */

/* These changes violate the PowerPC ABI.  Specifically, they change
   the way that space for a block return value is passed to a
   function.  The ABI says that the pointer is passed as a hidden
   first argument.  This is effectively the same issue as the one for
   the i386: the interface to objc_msgSend changes when the method
   returns an aggregate.  It seems that passing the value in r12 won't
   conflict with any other use.  */

/* Do NOT pass address of structure values as hidden parameters.  Instead
   pass them in r12.  */

#undef STRUCT_VALUE_INCOMING
#undef STRUCT_VALUE
#undef STRUCT_VALUE_REGNUM
#define STRUCT_VALUE_REGNUM 12

/* END Calling Convention CHANGES */

/* Changes for our assembler. */

/* Changes for our assembler. */

#undef TEXT_SECTION_ASM_OP
#define TEXT_SECTION_ASM_OP	"\t.text"
#undef DATA_SECTION_ASM_OP
#define DATA_SECTION_ASM_OP	"\t.data"
#undef CONST_SECTION_ASM_OP
#define CONST_SECTION_ASM_OP	"\t.const"

#undef ASM_OUTPUT_IDENT
#undef ASM_OUTPUT_SOURCE_FILENAME


#undef GLOBAL_ASM_OP
#define GLOBAL_ASM_OP		".globl"
#undef SKIP_ASM_OP
#define SKIP_ASM_OP		".space"
#undef COMMON_ASM_OP
#define COMMON_ASM_OP		".comm"
#undef LOCAL_ASM_OP
#define LOCAL_ASM_OP		".lcomm"
#undef FLOAT_ASM_OP
#define FLOAT_ASM_OP		".single"
#undef DOUBLE_ASM_OP
#define DOUBLE_ASM_OP		".double"
#undef INT_ASM_OP
#define INT_ASM_OP		".long"
#undef SHORT_ASM_OP
#define SHORT_ASM_OP		".short"
#undef CHAR_ASM_OP
#define CHAR_ASM_OP		".byte"
#undef ASCII_DATA_ASM_OP
#define ASCII_DATA_ASM_OP	".ascii"

#undef ASM_OUTPUT_INTERNAL_LABEL
#define ASM_OUTPUT_INTERNAL_LABEL(FILE,PREFIX,NUM)      \
  fprintf (FILE, "%s%d:\n", PREFIX, NUM)

#undef ASM_GENERATE_INTERNAL_LABEL

#ifndef MXW
#define ASM_GENERATE_INTERNAL_LABEL(LABEL,PREFIX,NUM)                   \
  sprintf (LABEL, "*%s%d", PREFIX, NUM)
#else
#define ASM_GENERATE_INTERNAL_LABEL(LABEL,PREFIX,NUM) \
  do {                                                \
     extern int currentLabelNumber;                   \
     if ( !strcmp(PREFIX,"LC") )                      \
        sprintf (LABEL, "*%s%d-%s%d", PREFIX, NUM, PREFIX, currentLabelNumber); \
     else                                                                       \
        sprintf (LABEL, "*%s%d", PREFIX, NUM);                                  \
	} while (0)
#endif


/* End of assembler changes */


#undef ASM_OUTPUT_SOURCE_LINE

/* Names to predefine in the preprocessor for this target machine.  */

#undef CPP_PREDEFINES
#define CPP_PREDEFINES "-Dm98000 -Dnrw -Dm98k -DNATURAL_ALIGNMENT -DNeXT -Dunix -D__MACH__ \
-D__BIG_ENDIAN__ -D__ARCHITECTURE__=\"m98k\" -D__CLASSIFY_TYPE__=2 " NEXT_PREDEFINES

/* Don't warn about nans, infinities or denorms.  */
#undef CHECK_FLOAT_VALUE

/* Only align functions to 4-byte boundaries.  */
#undef FUNCTION_BOUNDARY
#define FUNCTION_BOUNDARY 32

/* This accounts for the saved arg registers on the m88k. */
/* this needs to be reviewed: MXW */

#define OBJC_FORWARDING_STACK_OFFSET 32

#define OBJC_FORWARDING_REG_OFFSET 0

#define OBJC_FORWARDING_MIN_OFFSET 0

#define OBJC_FORWARDING_FIRST_REG 2

#undef ASM_FILE_START
#define ASM_FILE_START(FILE) \
  fprintf (FILE, ".include \"architecture/m98k/workaround.s\"\n"); \
  fprintf (FILE, "\t.file\t\"%s\"\n", dump_base_name);

#undef SIZE_TYPE

#undef JUMP_TABLES_IN_TEXT_SECTION

#undef ASM_DECLARE_FUNCTION_NAME(FILE,NAME,DECL)
#define ASM_DECLARE_FUNCTION_NAME(FILE,NAME,DECL)		\
{                                                               \
    {								\
      fprintf (FILE, "");				        \
      RS6000_OUTPUT_BASENAME (FILE, NAME);			\
      fprintf (FILE, ":\n");					\
    }								\
}

#undef ASM_DECLARE_OBJECT_NAME
#define ASM_DECLARE_OBJECT_NAME(FILE,NAME,DECL)  \
   ASM_DECLARE_FUNCTION_NAME(FILE,NAME,DECL)

#undef RS6000_OUTPUT_BASENAME
#define RS6000_OUTPUT_BASENAME(FILE, NAME)	\
    assemble_name (FILE, NAME);

#undef ASM_OUTPUT_EXTERNAL

#undef FUNCTION_PROFILER
#define FUNCTION_PROFILER(FILE, LABELNO) 
/* not implemented yet */

#undef ASM_GLOBALIZE_LABEL
#define ASM_GLOBALIZE_LABEL(FILE,NAME)	\
  do { fputs ("\t.globl ", FILE);	\
       RS6000_OUTPUT_BASENAME (FILE, NAME); fputs ("\n", FILE);} while (0)

#undef ASM_OUTPUT_SPECIAL_POOL_ENTRY

#undef FUNCTION_EPILOGUE
#define FUNCTION_EPILOGUE(FILE, SIZE) \
   output_epilog (FILE, SIZE); \
   fprintf(FILE, "\n");

#undef REGISTER_NAMES
#define REGISTER_NAMES                                          \
 {"r0", "r1", "r2", "r3", "r4", "r5", "r6", "r7", 		\
  "r8", "r9", "r10", "r11", "r12", "r13", "r14", "r15",		\
  "r16", "r17", "r18", "r19", "r20", "r21", "r22", "r23",	\
  "r24", "r25", "r26", "r27", "r28", "r29", "r30", "r31",	\
  "f0", "f1", "f2", "f3", "f4", "f5", "f6", "f7",		\
  "f8", "f9", "f10", "f11", "f12", "f13", "f14", "f15",		\
  "f16", "f17", "f18", "f19", "f20", "f21", "f22", "f23",	\
  "f24", "f25", "f26", "f27", "f28", "f29", "f30", "f31",	\
  "mq", "lr", "ctr", "ap",				        \
  "cr0", "cr1", "cr2", "cr3", "cr4", "cr5", "cr6", "cr7" }

/* 
Temporarily disable the usage of r0.  This will allow us to workaround
some hardware problems by re-writing sync instructions in such a way that
r0 can be clobbered without concern.
*/

#undef FIXED_REGISTERS
#define FIXED_REGISTERS  \
  {1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
   0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0}



extern char* powerToPowerpcOpcode();
#define ASM_OUTPUT_OPCODE(stream,ptr) \
   { ptr = powerToPowerpcOpcode(stream, ptr); }

#undef ASM_OUTPUT_ADDR_DIFF_ELT
#define ASM_OUTPUT_ADDR_DIFF_ELT(FILE, VALUE, REL)	\
  fprintf (FILE, "\t.long L%d-L%d\n", VALUE, REL);

#undef ASM_OUTPUT_EXTERNAL_LIBCALL
#define ASM_OUTPUT_EXTERNAL_LIBCALL(FILE, FUN)	\
{ fprintf (FILE, "\t.extern _");		\
  assemble_name (FILE, XSTR (FUN, 0));		\
  fprintf (FILE, "\n");				\
}

#undef ASM_OUTPUT_LABEL
#define ASM_OUTPUT_LABEL(FILE,NAME)	\
  do { fputs("_", FILE); RS6000_OUTPUT_BASENAME (FILE, NAME); fputs (":\n", FILE); } while (0)

#undef ASM_OUTPUT_LABELREF
#define ASM_OUTPUT_LABELREF(FILE,NAME)	\
  do { if (NAME[0] == '+' || NAME[0] == '-') fprintf (FILE, "\"%s\"", NAME); \
       else if (!strncmp (NAME, "_OBJC_", 6)) fprintf (FILE, "L%s", NAME);   \
       else if (!strncmp (NAME, ".objc_class_name_", 17))		\
       fprintf (FILE, "%s", NAME);					\
       else fprintf (FILE, "_%s", NAME); } while (0)

#undef ASM_OUTPUT_EXTERNAL
#undef ASM_OUTPUT_EXTERNAL_LIBCALL

#define ASM_OUTPUT_POOL_PROLOGUE(FILE, NAME, DECL, SIZE)  \
  {                                                       \
     extern char toc_buffer[];                            \
     readonly_data_section();                             \
     fprintf(FILE, "\t.align 2\n");                       \
     if ( NAME[0] == '+' || NAME[0] == '-')               \
        sprintf (toc_buffer, "\"%s_TOC\"", NAME);         \
     else                                                 \
        sprintf(toc_buffer, "%s_TOC", NAME);              \
     fprintf(FILE, "%s:\n", toc_buffer);                  \
  }

#define UPDATE_CURRENT_LABEL                           \
   do {                                                \
      extern int currentLabelNumber, const_labelno;    \
      currentLabelNumber = const_labelno;              \
   } while(0)

#undef DEFAULT_SIGNED_CHAR
#define DEFAULT_SIGNED_CHAR (1)

#undef ASM_OUTPUT_FLOAT
#define ASM_OUTPUT_FLOAT(FILE,VALUE)		\
  fprintf (FILE, "\t.single 0d%.20e\n", (VALUE))

#undef CASE_VECTOR_PC_RELATIVE

#undef ASM_OUTPUT_ADDR_VEC_ELT
#define ASM_OUTPUT_ADDR_VEC_ELT(FILE, VALUE)  \
  fprintf (FILE, "\t.long L%d\n", VALUE)

#undef STRICT_ALIGNMENT
#define STRICT_ALIGNMENT 1

#undef FRAME_POINTER_REQUIRED
#define FRAME_POINTER_REQUIRED \
  (frame_pointer_needed || write_symbols != NO_DEBUG)

#undef ASM_OUTPUT_REG_PUSH
#define ASM_OUTPUT_REG_PUSH(FILE,REGNO) \
  fprintf (FILE, "\tstwu %s,-4(r1)\n", reg_names[REGNO]);

#undef ASM_OUTPUT_REG_POP
#define ASM_OUTPUT_REG_POP(FILE,REGNO) \
  fprintf (FILE, "\tlwz %s,0(r1)\n\taddic r1,r1,4\n", reg_names[REGNO])


/* the following are the mneumonic changes between POWER and PowerPC 

   bcr == bclr
   bcrl == bclrl
   bcc == bcctr
   bccl == bcctrl
   svca == sc
   l == lwz
   lx == lwzx
   lu == lwzu
   lux == lwzux
   st == stw
   stx == stwx
   stu == stwu
   stux == stwux
   lbrx == lwbrx
   stbrx == stwbrx
   lm == lmw
   stm == stmw
   lsi == lswi
   lsx == lswx
   stsi == stswi
   stsx == stswx
   dcs == sync
   cal == addi
   cau == addis
   cax == add
   cax. == add.
   caxo == addo
   caxo. == addo.
   ai == addic
   ai. == addic.
   sfi == subfic
   a == addc
   a. == addc.
   ao == addco
   ao. == addco.
   sf == subfc
   sf. == subfc.
   sfo == subfco
   sfo. == subfco.
   ae == adde
   ae. == adde.
   aeo == addeo
   aeo. == addeo.
   sfe == subfe
   sfe. == subfe.
   sfeo == subfeo
   sfeo. == subfeo.
   ame == addme
   ame. == addme.
   ameo == addmeo
   ameo. == addmeo.
   sfme == subfme
   sfme. == subfme.
   sfmeo == subfmeo
   sfmeo. == subfmeo.
   aze == addze
   aze. == addze.
   azeo == addzeo
   azeo. == addzeo.
   sfze == subfze
   sfze. == subfze.
   sfzeo == subfzeo
   sfzeo. == subfzeo.
   muli == mulli
   muls == mull
   muls. == mull.
   mulso == mullo
   mulso. == mullo.
   ti == twi
   t == tw
   andil == andi
   andiu == andis
   oril == ori
   oriu == oris
   xoril == xori
   xoriu == xoris
   exts == extsh
   exts. == extsh.
   cntlz == cntlzw
   cntlz. == cntlzw.
   rlinm == rlwinm
   rlinm. == rlwinm.
   rlnm == rlwnm
   rlnm. == rlwnm.
   rlimi == rlwimi
   rlimi. == rlwimi.
   sl == slw
   sl. == slw.
   sr == srw
   sr. == srw.
   srai == srawi
   srai. == srawi.
   sra == sraw
   sra. == sraw.
   fa == fadd
   fa. == fadd.
   fs == fsub
   fs. == fsub.
   fm == fmul
   fm. == fmul.
   fd = fdiv
   fd. == fdiv.
   fma == fmadd
   fma. == fmadd.
   fms == fmsub
   fms. == fmsub.
   fnma == fnmadd
   fnma. == fnmadd.
   fnms == fnmsub
   fnms. == fnmsub.
*/



