/* m88k.h -- Assemble for the 88100
   Copyright (C) 1989 Free Software Foundation, Inc.

This file is not yet part of GAS, the GNU Assembler.

GAS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GAS; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef NeXT
/* different type of relocation available in the m88k */

enum reloc_type
{
  RELOC_LO16,			/* lo16(sym) for zero fill immediates */
  RELOC_HI16,			/* hi16(sym) */
  RELOC_PC16,			/* bb0, bb1, bcnd */
  RELOC_PC26,			/* br, bsr */
  RELOC_32,			/* jump tables, etc */
  RELOC_IW16,			/* global access through linker regs 28 */
  NO_RELOC
};

struct reloc_info_m88k
{
    unsigned long int r_address;
    unsigned int r_symbolnum: 24;
    unsigned int r_extern   : 1;
    unsigned int r_pad      : 3;
    enum reloc_type r_type  : 4;
    long int r_addend;
};

#define relocation_info reloc_info_m88k

#else defined(NeXT)
/*
 * On the NeXT all of the relocation entries of all the machines are defined
 * in reloc.h but to use GAS and not ifdef lots of code these macros are used.
 */
#define RELOC_VANILLA	M88K_RELOC_VANILLA
#define RELOC_PC16	M88K_RELOC_PC16
#define RELOC_PC26	M88K_RELOC_PC26
#define RELOC_LO16	M88K_RELOC_LO16
#define RELOC_HI16	M88K_RELOC_HI16
#define NO_RELOC	0x10 /* out side the range of r_type:4 */
#endif NeXT
