/* strstr - find first occurrence of wanted in s
   Copyright (C) 1989, Free Software Foundation.

This file is part of GAS, the GNU Assembler.

GAS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GAS; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */
   


#define CONST
#define SIZET int

#define	NULL	0

char *				/* found string, or NULL if none */
strstr(s, wanted)
CONST char *s;
CONST char *wanted;
{
	register CONST char *scan;
	register SIZET len;
	register char firstc;

	/*
	 * The odd placement of the two tests is so "" is findable.
	 * Also, we inline the first char for speed.
	 * The ++ on scan has been moved down for optimization.
	 */
	firstc = *wanted;
	len = strlen(wanted);
	for (scan = s; *scan != firstc || strncmp(scan, wanted, len) != 0; )
		if (*scan++ == '\0')
			return(NULL);
	return(scan);
}
#ifdef NeXT
char *				/* found string, or NULL if none */
strstrn(s, wanted, n)
CONST char *s;
CONST char *wanted;
int n;
{
	register CONST char *scan;
	register SIZET len;
	register char firstc;
	char *lim;

	/*
	 * The odd placement of the two tests is so "" is findable.
	 * Also, we inline the first char for speed.
	 * The ++ on scan has been moved down for optimization.
	 */
	lim = s + n;
	firstc = *wanted;
	len = strlen(wanted);
#if 0
	for (scan = s; *scan != firstc || strncmp(scan, wanted, len) != 0; )
		if (scan++ >= lim)
			return(NULL);
	return(scan);
#endif
	scan = s;
	while(n >= len) {
	  if (strncmp(scan, wanted, len) == 0)
	    return(scan);
	  scan++;
	  n--;
	}
	return(NULL);
}
#endif NeXT
