#import <objc/Object.h>
#import <objc/List.h>

#import "Value.h"
#import "ValueGetting.h"

@class Block;

@protocol BlockGetter
-(List *)blockValuesFor: (void *)data;
-(char *)nameForPC: (unsigned)pc;
-(int)hasSymbolsForPC: (unsigned)pc;
-(Block *)makeBlock: (unsigned)pc;
@end

@interface Block : Object
<BaseValueGetting>
{
    id superBlock;
    unsigned start;
    unsigned end;
    List *locals;
    void *data;
}

+(void)setBlockGetter: (id <BlockGetter>)theGetter;
-(List *)locals;
-(int)numLocals;
-(void)setStart: (unsigned)theStart;
-(unsigned)start;
-(void)setEnd: (unsigned)theEnd;
-(unsigned)theEnd;
-(void)setData: (void *)theData;
-(void)setSuperBlock: (Block *)theSuperBlock;
-(Block *)superBlock;
-(char *)functionName;

@end

@interface Frame : Object
<BaseValueGetting>
{
@public
    Block *block;
    unsigned frame;
    unsigned pc;
}
-(Value *)subValueAt: (int)nSubValue;
-(int)numSubValues;
-(int)hasSymbols;
-(char *)functionName;
-(char *)functionNameAndHasSymbols: (int *)hasSymbols;
-(unsigned)frame;
-(void)setFrame: (unsigned)theFrame;
-(unsigned)pc;
-(void)setPC: (unsigned)thePC;
-(unsigned)pc;
@end

@interface BlockList : List

-(Block *)blockForPC: (unsigned)pc;

@end