@class Value;
@class Type;

@protocol BaseValueGetting
-(int)numSubValues;
-(Value *)subValueAt: (int)nValue;
-(Value *)subValueAt: (int)nValue
           withFlags: (out unsigned *)pFlags
	     andName: (out char **)pName;
-subValueAt: (int)nValue;
-subValueAt: (int)nValue
           withFlags: (out unsigned *)pFlags
	     andName: (out char **)pName;
-subValueNamed: (in char *)valueName index:(out int *)index;
-(Value *)subValueFor: (Value *)value from: (int *)from index: (int *)index;
@end

@protocol ValueGetting <BaseValueGetting>

-(char *)valueName;
-(Type *)type;
-(unsigned)size;
-(unsigned)scalerValueFrom: (unsigned)from;
-(float)floatValueFrom: (unsigned)from;
-(char *)enumValueFrom: (unsigned)from;
-(char *)stringValueFrom: (unsigned)from;
-(char *)functionValueFrom: (unsigned)from;
-(unsigned)addressFrom: (unsigned)from;
-(unsigned)addressFrom: (unsigned)from isValid: (out int *)isValid;
-(unsigned)flags;
-(char *)typeName;
-(int)castToTypeNamed: (in char *)typeName from: (unsigned)from;

@end